
var  userLogined = false;
var  revert = false;
var selectedFontClass = "icon-font-selected";

/**
* private method used for load data
*/

// 加载问题部分的内容
function loadQuestion(qaContent) {
	// origin
	if(qaContent.origin != null){
	    document.getElementById("origin").style.display="inline-block";
        document.getElementById("origin").innerHTML=qaContent.origin;
        document.getElementById("origin").onclick = toPlay
	}else{
	    document.getElementById("origin").style.display="none";
	}

	// question title
	document.getElementById("question_title").innerText=qaContent.title;
	var maxLen = 12;
	// auther
    if(qaContent.nickname.length > maxLen){
        document.getElementById("author").innerHTML=qaContent.nickname.substring(0,maxLen)+"...";
    }else{
        document.getElementById("author").innerHTML=qaContent.nickname
    }
	// answer num
	document.getElementById("answer_num").innerHTML=qaContent.answerNums + "个回答";
	// answer time
    if(qaContent.editTime == null){
    	    document.getElementById("update_time").innerHTML=qaContent.createTime;
    }else{
        document.getElementById("update_time").innerHTML=qaContent.editTime + " 编辑过";
    }
	// questin dec
	document.getElementById("question_dsc").innerHTML=qaContent.description;

}


// 加载回答
function createAnswer(answer, showAllAdopt) {
	var htmlStr = [];
	htmlStr.push(
    		"<div class='answer-item'>",
    			"<div class='answer-title'>",
    				"<img class='answer-photo' onClick='goUserCenter("+answer.mcUserModel.id+")' src='"+answer.mcUserModel.imageUrl+"'> ",
    				"<div class='answer-name-parent'>"
    				    +"<p><span class='answer-name'>"+answer.mcUserModel.nickname
    				    +(answer.userType == 2 ? "<img class='answer-teacher-icon' src='file:///android_asset/teacher_icon.png'>" : "")
    				    +"</span></p>"
    				    +"<p><span class='answer-time'>" + answer.createTime + "</span></p>"
    				+"</div>",
    				showAllAdopt ? "<span name='answer_adopted_name' id ='answer_adopte_btn_"+answer.id
    				+"' class='answer-adopt-btn' onClick='adoptAnswer("+answer.id+", "+answer.mcUserModel.id
    				+")'>采纳</span>" : answer.adopted ? "<span name='answer_adopted_name' id ='answer_adopte_btn_"
    				+answer.id+"' class='answer-adopted'>已采纳</span>" : "" ,
    				"<br>",
    			"</div>",
    			"<div id='answer_dsc' class='answer-dsc'>"+answer.description+"</div>",
    			"<div class='answer-bottom'>",
                    "<span id='thumb_up_"+answer.id+"' onClick='praiseAnswer("+answer.id+")' class='icon-thumb_up icon-font-style "
                    + (answer.isSupport ? selectedFontClass:"")+ "'></span>",
                    "<span id='praised_num_"+answer.id+"' onClick='praiseAnswer("+answer.id+")' class='answer-bottom-num-style answer-adopted-num-padding "
                    + (answer.isSupport ? selectedFontClass:"")+ "'>"+answer.supportNum+"</span>",
                    "<span class='icon-sms icon-font-style' onClick='openComment("+answer.id+")'></span>",
                    "<span id='comment_num_"+answer.id+"' class='answer-bottom-num-style' onClick='openComment("+answer.id+")'>"+answer.replyNum+"</span>",
    			"</div>",
    		"</div>"
    		);
	var answers = document.getElementById("answer_info");
	answers.insertAdjacentHTML('beforeend', htmlStr.join(''));
}

// 去用户中心
function goUserCenter(userId) {
    careerPathQaDetail.userCenter(userId);
}

// 采纳答案
function adoptAnswer(answerId) {
	if (!checkUserLogin()) return;
	// 向外请求采纳答案；
    careerPathQaDetail.adoptAnswer(answerId);
}

// 赞答案
function praiseAnswer (answerId) {
	if (!checkUserLogin()) return;
	var praiseNum = document.getElementById('praised_num_'+answerId);
	var thumbUp = document.getElementById('thumb_up_'+answerId);

	if (!hasClass(thumbUp, selectedFontClass)) {
		// 赞变红
		praiseNum.innerHTML = parseInt(praiseNum.innerHTML) + 1;
		addClass(praiseNum, selectedFontClass);
		addClass(thumbUp, selectedFontClass);
        careerPathQaDetail.praiseAnswer(answerId);
	}/*取消赞不需要了else {
		// 如果答案已经被赞，取消赞
		praiseNum.innerHTML = parseInt(praiseNum.innerHTML) - 1;
		removeClass(thumbUp, selectedFontClass);
		removeClass(praiseNum, selectedFontClass);
		window.location.href=innerSchema+unPraisePath+answerId;
	}*/
}

// 评论答案
function openComment(answerId) {
    careerPathQaDetail.comment(answerId);
}

// 用户是否登录的检测
function checkUserLogin() {
	if (userLogined)
		return true;
	careerPathQaDetail.login();
	return false;
}

// 去播放
function toPlay(){
    careerPathQaDetail.play();
}

function removeClass(obj, cln) {
	if (hasClass(obj, cln)) {
    	var reg = new RegExp('(\\s|^)' + cln + '(\\s|$)');
       	obj.className = obj.className.replace(reg, ' ');
  	}
}

function addClass(obj, cln) {
	if (!hasClass(obj, cln))
	 	obj.className += " " + cln;
}

function hasClass(obj, cln) {
	return obj.className.indexOf(cln) > -1;
}

/***
* the blow method is provide for native to operate
* 以下是native（java） 层可调用的代码
*/

// 用户在native（java）层评论了此答案，此时我们需要为答案评论数目＋1
function commentAnswer(answerId) {
	var num = document.getElementById('comment_num_'+answerId).innerHTML;
	document.getElementById('comment_num_'+answerId).innerHTML = parseInt(num)+1;
}

// 有答案被采纳了，native层提交服务器成功然后隐藏其它的被采纳按钮
function adoptedOneAnswer(answerId) {
	// 隐藏采纳按钮，显示被采纳描述
	var allAdopBtn = document.getElementsByName('answer_adopted_name');
	for (var i=0;i<allAdopBtn.length;i++) {
		if (allAdopBtn[i].id.length==(allAdopBtn[i].id.indexOf(answerId)+answerId.length)) {
			allAdopBtn[i].innerHTML='已采纳';
			allAdopBtn[i].className="answer-adopted";
			allAdopBtn[i].onclick = null;
		} else {
			allAdopBtn[i].style.display="none";
		}

	}
}

// 加载数据
function loadData(content, uid) {
    var qaContent = JSON.parse(content)
    var myuid = parseInt(uid);
	// 判断用户是否登录
	userLogined = myuid == 0 ? false : true;

	loadQuestion(qaContent);

	// answer items
	// 问题是我发布的 并且还未采纳答案 就显示采纳按钮
	var showAllAdopt = myuid == qaContent.userId && qaContent.adoptedAnswerId == 0;

	document.getElementById("answer_info").innerHTML = "";
	if(qaContent.answerModels != null){
        document.getElementById('answer_num').style.visibility="visible"
        for (var i=0;i<qaContent.answerModels.length;i++) {
            // 自己的答案不显示采纳
            if (qaContent.answerModels[i].mcUserModel == undefined) {
                continue;
            }
            var answerUid = qaContent.answerModels[i].mcUserModel.id;
            var showAdopt = answerUid == myuid ? false : showAllAdopt;
            createAnswer(qaContent.answerModels[i], showAdopt);
        }
	}else{
	    document.getElementById('answer_num').style.visibility="hidden"
	}
	addImgClick();
}

function addImgClick() {
	var objs = document.getElementsByTagName('img');
	for (var i=0;i<objs.length;i++) {
		if (!hasClass(objs[i], "answer-photo")) {
			objs[i].onclick = function () {
				window.location.href=this.src;
			}
		}
		
	}
}


